"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CoreQueue = void 0;
const core_queue_1 = require("./core-queue");
Object.defineProperty(exports, "CoreQueue", { enumerable: true, get: function () { return core_queue_1.CoreQueue; } });
function timeoutTask(id, timeoutMs) {
    return new Promise((resolve, reject) => {
        const start = performance.now();
        setTimeout(() => {
            console.log(`Task ${id} completed.`);
            resolve(start);
        }, timeoutMs);
    });
}
function getRandomIntInclusive(min, max) {
    min = Math.ceil(min);
    max = Math.floor(max);
    return Math.floor(Math.random() * (max - min + 1) + min);
}
function example() {
    const coreQueue = new core_queue_1.CoreQueue({
        maxConcurrency: 1,
        maxTasks: 10,
        autostart: true
    });
    for (let i = 0; i < 10; i++) {
        coreQueue
            .enqueue(() => timeoutTask(i, getRandomIntInclusive(500, 1000)))
            .then((start) => { console.log(`Done in ${Math.round(performance.now() - start)}ms`); })
            .catch((error) => { console.log(`Error occured ${error.message}`); });
    }
}
example();
